#!/usr/bin/perl
#
# $Id: norm.pl,v 1.5 2002/09/10 12:36:08 homyakov Exp $
#

use strict;
use warnings;

use RPM::Header;
use Getopt::Std;

sub usage () {
    die "Usage: norm.pl [-v] [-d] directory
    -v        verbose mode
    -d        debuging\n"; 
}

usage unless ( $#ARGV >= 0 );

my %Options;
my $Verbouse = 0;
my $Debug = 0;

getopts('dv', \%Options);

if ( $Options{v} ) {  $Verbouse = 1; }; 
if ( $Options{d} ) {  $Debug = 1;    }; 

my $dir = shift;

die "$dir should be a directory with '+w' '+x' permissons!\n"
    unless ( -d $dir && -w _ && -x _ );

my $count = 0;
while ( <$dir/*.rpm> ) {
    my $href = new RPM::Header "$_"; 
    unless ( defined( $href ) ) { 
	warn "Error: $RPM::err";
	next; 
    }
    my $filename = join( '.', 
			join( '-', 
			     $href->{name}, 
			     $href->{version}, 
			     $href->{release} ),
			$href->{arch}, 'rpm' );
    $filename = "$dir/$filename";		
    if ( $_ ne $filename ) {
	print "Rename $_ to $filename\n" if ( $Debug );
	rename( $_, $filename ) 
	  ? $count++
	  : warn "Rename $_ to $filename error: $!\n";
    } else {
    	print "$_ is not changed\n" if ( $Debug );
    }
}

print "Renamed: $count files\n" if ( $Verbouse );

__END__
